
#ifndef ATOMCLUSTER_H
#define ATOMCLUSTER_H

#include "atom.h"
#include "atomGrid.h"
#include "box.h"
#include "coordinate3D.h"

#include <stdio.h>

class AtomCluster {

 public:
  AtomCluster(int aNum);
  ~AtomCluster();

  int getAtomCount();
  Box* getBox();   // DEBUGGING METHOD
  void setBox(Box* b);
  AtomGrid* makeGrid();  // DEBUGGING METHOD
  Coordinate3D* getRandomVolumeCoord3D();
  Coordinate3D* getRandomNullCoord3D();
  Coordinate3D* getRandomBoxCoord3D();
  int addAtom(Atom* atom);

 private:
  int createBox();
  int isInVolume(Coordinate3D* coord);
  int isInVolume2(Coordinate3D* coord);

 private:
  Atom** atoms;
  AtomGrid* grid;
  int atomNum;
  int atomCount;
  Box* box;

};

#endif
