
#include "box.h"


// Constructor
//
Box::Box(Coordinate3D* o, float w, float h, float d) :
  width(w), height(h), depth(d) {

  origin = new Coordinate3D(o->getX(),o->getY(),o->getZ());

  //printf("  origin: (%f, %f, %f)\n",origin->getX(),origin->getY(),origin->getZ());
  //printf("  width:  %f\n",width);
  //printf("  height: %f\n",height);
  //printf("  depth:  %f\n",depth);

  return;
}


// Destructor
//
Box::~Box() {

  delete origin;

  return;
}


// getOrigin
//
Coordinate3D* Box::getOrigin() {

  return origin;
}


// getWidth
//
float Box::getWidth() {

  return width;
}


// getHeight
//
float Box::getHeight() {

  return height;
}


// getDepth
//
float Box::getDepth() {

  return depth;
}


// getVolume
float Box::getVolume() {

  return (width * height * depth);
}


// getRandomCoord3D
//
Coordinate3D* Box::getRandomCoord3D() {

  float x =  width * ((float)rand() / (float)RAND_MAX);
  float y = height * ((float)rand() / (float)RAND_MAX);
  float z =  depth * ((float)rand() / (float)RAND_MAX);

  //printf("  origin: (%f, %f, %f)\n",origin->getX(),origin->getY(),origin->getZ());
  //printf("  x: %f\n",x);
  //printf("  y: %f\n",y);
  //printf("  z: %f\n",z);

  x += origin->getX();
  y += origin->getY();
  z += origin->getZ();

  return new Coordinate3D(x,y,z);
}


// clone
//   Make a copy of the box
Box* Box::clone() {

  return new Box(origin, width, height, depth);
}
