
#include "elementBuilder.h"

// Constructor
//
ElementBuilder::ElementBuilder() {

  elementCount = 23;
  elements = new Element*[elementCount];

  for (int i=0; i<elementCount; i++) {
    elements[i] = 0;
  }

  return;
}


// Destructor
ElementBuilder::~ElementBuilder() {

  // XXX - NEED AUTOMATED WAY TO CHECK NUMBER OF ELEMENTS IN ENUM
  for (int i=0; i<elementCount; i++) {
    if (elements[i] != 0) {
      delete elements[i];
    }
  }

  delete elements;

  return;
}


Element* ElementBuilder::getElement(char* symbol) {

  //printf("=>getElement()\n");

  if (strlen(symbol) == 1) {
    if (symbol[0] == 'H') {
      return getH();
    }
    if (symbol[0] == 'C') {
      return getC();
    }
    if (symbol[0] == 'N') {
      return getN();
    }
    if (symbol[0] == 'O') {
      return getO();
    }
    if (symbol[0] == 'F') {
      return getF();
    }
    if (symbol[0] == 'P') {
      return getP();
    }
    if (symbol[0] == 'S') {
      return getS();
    }
    if (symbol[0] == 'K') {
      return getK();
    }
    if (symbol[0] == 'I') {
      return getI();
    }
  }
  else if (strlen(symbol) == 2) {
    if (symbol[0] == 'N' && symbol[1] == 'a') {
      return getNa();
    }
    if (symbol[0] == 'M' && symbol[1] == 'g') {
      return getMg();
    }
    if (symbol[0] == 'A' && symbol[1] == 'l') {
      return getAl();
    }
    if (symbol[0] == 'S' && symbol[1] == 'i') {
      return getSi();
    }
    if (symbol[0] == 'C' && symbol[1] == 'l') {
      return getCl();
    }
    if (symbol[0] == 'C' && symbol[1] == 'a') {
      return getCa();
    }
    if (symbol[0] == 'M' && symbol[1] == 'n') {
      return getMn();
    }
    if (symbol[0] == 'F' && symbol[1] == 'e') {
      return getFe();
    }
    if (symbol[0] == 'C' && symbol[1] == 'o') {
      return getCo();
    }
    if (symbol[0] == 'N' && symbol[1] == 'i') {
      return getNi();
    }
    if (symbol[0] == 'C' && symbol[1] == 'u') {
      return getCu();
    }
    if (symbol[0] == 'Z' && symbol[1] == 'n') {
      return getZn();
    }
    if (symbol[0] == 'B' && symbol[1] == 'r') {
      return getBr();
    }
    if (symbol[0] == 'M' && symbol[1] == 'o') {
      return getMo();
    }
  }

  printf("Element not known: %s\n",symbol);
  printf("<=getElement(): 0\n");

  return 0;
}


// getH
//
Element* ElementBuilder::getH() {

  if (elements[H] == 0) {
    elements[H] = new Element("H",1.20);
  }

  return elements[H];
}


// getC
//
Element* ElementBuilder::getC() {

  if (elements[C] == 0) {
    //printf("   HEY!!!!!\n");
    elements[C] = new Element("C",1.70);
  }

  return elements[C];
}


// getN
//
Element* ElementBuilder::getN() {

  if (elements[N] == 0) {
    elements[N] = new Element("N",1.55);
  }

  return elements[N];
}


// getO
//
Element* ElementBuilder::getO() {

  if (elements[O] == 0) {
    elements[O] = new Element("O",1.52);
  }

  return elements[O];
}


// getF
//
Element* ElementBuilder::getF() {

  if (elements[F] == 0) {
    elements[F] = new Element("F",1.47);
  }

  return elements[F];
}


// getNa
//
Element* ElementBuilder::getNa() {

  if (elements[NA] == 0) {
    elements[NA] = new Element("Na",2.27);
  }

  return elements[NA];
}


// getMg
//
Element* ElementBuilder::getMg() {

  if (elements[MG] == 0) {
    elements[MG] = new Element("Mg",1.73);
  }

  return elements[MG];
}


// getAl
//
Element* ElementBuilder::getAl() {

  if (elements[AL] == 0) {
    elements[AL] = new Element("Al",2.00);
  }

  return elements[AL];
}


// getSi
//
Element* ElementBuilder::getSi() {

  if (elements[SI] == 0) {
    elements[SI] = new Element("Si",2.10);
  }

  return elements[SI];
}


// getP
//
Element* ElementBuilder::getP() {

  if (elements[P] == 0) {
    elements[P] = new Element("P",1.80);
  }

  return elements[P];
}


// getS
//
Element* ElementBuilder::getS() {

  if (elements[S] == 0) {
    elements[S] = new Element("S",1.80);
  }

  return elements[S];
}


// getCl
//
Element* ElementBuilder::getCl() {

  if (elements[CL] == 0) {
    elements[CL] = new Element("Cl",1.75);
  }

  return elements[CL];
}


// getK
//
Element* ElementBuilder::getK() {

  if (elements[K] == 0) {
    elements[K] = new Element("K",2.75);
  }

  return elements[K];
}


// getCa
//
Element* ElementBuilder::getCa() {

  if (elements[CA] == 0) {
    elements[CA] = new Element("Ca",2.00);
  }

  return elements[CA];
}


// getMn
//
Element* ElementBuilder::getMn() {

  if (elements[MN] == 0) {
    elements[MN] = new Element("Mn",2.00);
  }

  return elements[MN];
}


// getFe
//
Element* ElementBuilder::getFe() {

  if (elements[FE] == 0) {
    elements[FE] = new Element("Fe",2.00);
  }

  return elements[FE];
}


// getCo
//
Element* ElementBuilder::getCo() {

  if (elements[CO] == 0) {
    elements[CO] = new Element("Co",2.00);
  }

  return elements[CO];
}


// getNi
//
Element* ElementBuilder::getNi() {

  if (elements[NI] == 0) {
    elements[NI] = new Element("Ni",1.63);
  }

  return elements[NI];
}


// getCu
//
Element* ElementBuilder::getCu() {

  if (elements[CU] == 0) {
    elements[CU] = new Element("Cu",1.40);
  }

  return elements[CU];
}


// getZn
//
Element* ElementBuilder::getZn() {

  if (elements[ZN] == 0) {
    elements[ZN] = new Element("Zn",1.39);
  }

  return elements[ZN];
}


// getBr
//
Element* ElementBuilder::getBr() {

  if (elements[BR] == 0) {
    elements[BR] = new Element("Br",1.85);
  }

  return elements[BR];
}


// getMo
//
Element* ElementBuilder::getMo() {

  if (elements[MO] == 0) {
    elements[MO] = new Element("Mo",2.00);
  }

  return elements[MO];
}


// getI
//
Element* ElementBuilder::getI() {

  if (elements[I] == 0) {
    elements[I] = new Element("I",1.98);
  }

  return elements[I];
}
