
#ifndef NEURONLIST_H
#define NEURONLIST_H

#include "coordinate3D.h"

#include <math.h>
#include <stdio.h>

class NeuronNode {

 public:
  NeuronNode(Coordinate3D* c, int i, float d);
  ~NeuronNode();

  //NeuronNode* getNext();
  //NeuronNode* getPrev();
  Coordinate3D* getCoord();
  int getIndex();
  float getDistance();
  //int setNext(NeuronNode* n);
  //int setPrev(NeuronNode* p);
  //int isLessThan(NeuronNode* n);
  //int isGreaterThan(NeuronNode* n);

  //private:
  NeuronNode* next;
  NeuronNode* prev;
  Coordinate3D* coord;
  int index;
  float distance;
  
};


class NeuronList {

 public:
  NeuronList(Coordinate3D** coords, int coordCount, Coordinate3D* f);
  ~NeuronList();

  int getFirstIndex();
  int getSecondIndex();
  int contract(float stepSize, float lambda);

 private:
  //int addNeuronNode(Coordinate3D* coord, int index, float distance);
  int quicksortNodes(int first, int last);
  int checkOrder();   // DEBUG METHOD

 private:
  //NeuronNode* head;
  //NeuronNode* current;
  NeuronNode** nodes;
  Coordinate3D* focus;
  int neuronCount;

};

#endif
