
#ifndef PSFREADER_H
#define PSFREADER_H

class PsfReader {

 public:
  /** Constructor. */
  PsfReader();

  /** Destructor. */
  ~PsfReader();

  
  /** 
   * Set the name of the psf file.
   * @param fn char*: filename.
   * @return int: 0 on fail, 1 on success.
   */
  int setFilename(char* fn);

  /**
   * Set the path of the psf file.
   * @param p char*: path.
   * @return int: 0 on fail, 1 on success.
   */
  int setPath(char* p);

 private:
  int checkFullName();
  int checkPsfFile(char* file);
  int setNameFromFilename();

 public:
  char* filename;
  char* path;      // Path to the file
  char* fullName;
  char* structureName;

};

#endif
