
#include "baseGraph.h"
#include "baseVertexNodeTree.h"
#include "coordinate3D.h"
#include "genericList.h"
#include "groupId.c"
//#include "genericList.c"
#include "tessellationScriptReader.h"
#include "triangleGraph.h"
#include "triangleGraphNode.h"

#include <stdio.h>
//#include <stdlib.h>


int main (int argc, char** argv) {

  // GenericList
  printf("*** GenericList Test ***\n");
  
  GenericList<int>* list1 = new GenericList<int>();
  list1->push(1);
  list1->push(2);
  list1->push(3);
  list1->push(4);
  list1->printList();
  list1->push(5);
  list1->push(6);
  list1->push(7);

  list1->printList();
  printf("  length: %d\n",list1->getLength());
  printf("  pop: %d\n",(int)list1->pop());
  //list1->printList();
  printf("  length: %d\n",list1->getLength());
  printf("  pop: %d\n",(int)list1->pop());
  printf("  length: %d\n",list1->getLength());
  printf("  front: %d\n",(int)list1->front());
  list1->printList();
  printf("  length: %d\n",list1->getLength());
  printf("  front: %d\n",(int)list1->front());
  printf("  length: %d\n",list1->getLength());
  printf("  front: %d\n",(int)list1->front());
  printf("  length: %d\n",list1->getLength());
  printf("  pop: %d\n",(int)list1->pop());
  printf("  length: %d\n",list1->getLength());
  printf("  pop: %d\n",(int)list1->pop());
  printf("  length: %d\n",list1->getLength());
  printf("  pop: %d\n",(int)list1->pop());
  printf("  length: %d\n",list1->getLength());
  printf("  pop: %d\n",(int)list1->pop());
  printf("  length: %d\n",list1->getLength());
  list1->printList();
  
  
  //Coordinate3D* blah = new Coordinate3D(1.0,2.0,3.0);

  //GenericList<char> list2;
  //int a = 4;
  //list1.push(&a);

  /*
    GenericList<int>* list1 = new GenericList<int>();
    int a = 4;
    int b = 3;
    int c = 2;
    int d = 1;
    list1->push(&a);
    list1->push(&b);
    list1->push(&c);
    list1->push(&d);
    list1->printList();
  */


  // BaseVertexNode
  printf("*** BaseVertexNode Test ***\n");
  Coordinate3D* coord1 = new Coordinate3D(0.0,0.0,0.0);
  Coordinate3D* coord2 = new Coordinate3D(1.0,1.0,0.0);
  Coordinate3D* coord3 = new Coordinate3D(-1.0,1.0,0.0);
  BaseVertexNode* bvNode1 = new BaseVertexNode(coord1);
  BaseVertexNode* bvNode2 = new BaseVertexNode(coord2);
  BaseVertexNode* bvNode3 = new BaseVertexNode(coord3);
  bvNode1->setId(0);
  bvNode2->setId(1);
  bvNode3->setId(2);
  GroupId* group = new GroupId(5);
  bvNode1->setGroupId(group);
  bvNode2->setGroupId(group);
  bvNode3->setGroupId(group);
  bvNode1->print();
  bvNode2->print();
  bvNode3->print();
  printf("******\n");
  bvNode1->addVertex(bvNode2);
  bvNode2->addVertex(bvNode1);
  bvNode1->print();
  bvNode2->print();
  bvNode3->print();
  BaseVertexNode* bvNode4 = bvNode1->getFirstVertex();
  BaseVertexNode* bvNode5 = bvNode4->getFirstVertex();
  printf("******\n");
  bvNode4->print();
  bvNode5->print();

  printf("\n\n");


  // BaseVertexNodeTree
  printf("*** BaseVertexNodeTree Test ***\n");
  BaseVertexNodeTree* bvnt1 = new BaseVertexNodeTree(bvNode1);
  bvnt1->insert(bvNode2);
  bvnt1->insert(bvNode3);
  BaseVertexNode* bvNode6 = bvnt1->retrieve(coord2);
  BaseVertexNode* bvNode7 = bvnt1->retrieve(coord3);
  bvNode6->print();
  bvNode7->print();

  printf("\n\n");


  // BaseGraph
  printf("*** BaseGraph Test ***\n");
  BaseGraph* graph1 = new BaseGraph(3);
  graph1->addVertex(coord1);
  graph1->addVertex(coord2);
  graph1->addVertex(coord3);
  graph1->print();
  printf("******\n");
  graph1->deactivateAll();
  graph1->print();
  printf("******\n");
  graph1->activateAll();
  graph1->print();
  printf("******\n");
  graph1->addEdge(coord1,coord2);
  graph1->print();

  printf("\n\n");


  // TessellationScriptReader
  printf("*** TessellationScriptReader Test ***\n");
  TessellationScriptReader* tsr = new TessellationScriptReader();
  tsr->setPath("./SynAsp10/");
  //tsr->setFilename("testTess.tcl");
  //tsr->setFilename("testTess1.tcl");
  tsr->setFilename("tess27.tcl");
  BaseGraph* graph2 = tsr->getBaseGraph();
  //graph2->print();
  printf("******\n");
  //graph2->deactivateAll();
  //graph2->print();
  graph2->deactivateLongEdges();
  FILE* outfile = fopen("SynAsp10/prune.tcl","w");
  graph2->printTessellationScript(outfile);
  fclose(outfile);
  printf("\n\n");


  // TriangleGraphNode
  printf("*** TriangleGraphNode Test ***\n");
  Coordinate3D* coord4 = new Coordinate3D(0.0,-1.0,-1.0);
  Coordinate3D* coord5 = new Coordinate3D(0.0,-1.0,1.0);
  Coordinate3D* coord6 = new Coordinate3D(1.0,1.0,1.0);
  BaseVertexNode* bvNode8  = new BaseVertexNode(coord4);
  BaseVertexNode* bvNode9  = new BaseVertexNode(coord5);
  BaseVertexNode* bvNode10 = new BaseVertexNode(coord6);
  TriangleGraphNode* tgNode1 = new TriangleGraphNode(bvNode1,bvNode2,bvNode3);
  tgNode1->setId(0);
  TriangleGraphNode* tgNode2 = new TriangleGraphNode(bvNode8,bvNode9,bvNode10);
  tgNode2->setId(1);
  TriangleGraphNode* tgNode3 = new TriangleGraphNode(bvNode8,bvNode2,bvNode3);
  tgNode3->setId(2);
  tgNode1->print();
  tgNode2->print();
  tgNode3->print();

  printf("\n\n");


  // TriangleGraph
  printf("*** TriangleGraph Test ***\n");
  TriangleGraph* tGraph1 = new TriangleGraph(4);
  tGraph1->addVertex(bvNode2,bvNode3,bvNode8);
  tGraph1->addVertex(bvNode2,bvNode3,bvNode9);
  tGraph1->addVertex(bvNode2,bvNode8,bvNode9);
  tGraph1->addVertex(bvNode3,bvNode8,bvNode9);
  /*
    tGraph1->print();
    outfile = fopen("snork.tcl","w");
    tGraph1->printTessellationScript(outfile);
    fclose(outfile);
  */
  printf("******\n");
  TriangleGraph* tGraph2 = graph2->getTriangleGraph();
  //tGraph2->print();
  outfile = fopen("SynAsp10/surface.tcl","w");
  tGraph2->printTessellationScript(outfile);
  fclose(outfile);

  printf("\n\n");


  return 0;
}
