
#include "atom.h"
#include "atomCluster.h"
#include "baseGraph.h"
#include "baseVertexNodeTree.h"
#include "box.h"
#include "connectionMatrix.h"
#include "coordinate3D.h"
#include "element.h"
#include "elementBuilder.h"
#include "genericList.h"
#include "groupId.c"
#include "neuronList.h"
#include "pdbReader.h"
#include "tessellationScriptReader.h"
#include "tessellator.h"
#include "triangleGraph.h"
#include "triangleGraphNode.h"

#include <stdio.h>
//#include <stdlib.h>


int main (int argc, char** argv) {

  // Atom
  printf("*** Atom Test ***\n");
  ElementBuilder* eb = new ElementBuilder();

  printf("\n\n");


  // PdbReader
  printf("*** PdbReader Test ***\n");
  PdbReader* pdbReader = new PdbReader();
  pdbReader->setPath("./Test/Cyt/");
  //pdbReader->setFilename("hisHhisF.pdb");
  pdbReader->setFilename("RCcytOnly_ox_eq_elev_3A-heme.pdb");
  //pdbReader->setFilename("RCcytOnly_ox_eq-heme.pdb");
  //pdbReader->setFilename("RCcytOnly_ox_eq_elev_3A-heme.pdb");
  //pdbReader->setFilename("RCcytOnly_ox_eq_elev_10A-heme.pdb");
  //pdbReader->setFilename("RCcytOnly_ox_eq_pull_24A-heme.pdb");
  //pdbReader->setFilename("1asy.pdb");
  //pdbReader->setFilename("1a9x-AB.pdb");
  //pdbReader->setFilename("1c0a-prot.pdb");
  AtomCluster* ac2 = pdbReader->getAtomCluster(0, eb);
  //tempCoord = new Coordinate3D(0.0,-15.0,40.0);
  //box = new Box(tempCoord,20.0,35.0,40.0);
  Coordinate3D* tempCoord5 = new Coordinate3D(-16.0,-15.0,19.0);
  Box* box5 = new Box(tempCoord5,34.0,30.0,12.0);
  ac2->setBox(box5);
  delete tempCoord5;
  delete box5;
    
  printf("\n\n");


  // TessellationScriptReader
  printf("*** TessellationScriptReader Test 1 ***\n");
  TessellationScriptReader* tsr = new TessellationScriptReader();
  tsr->setPath("./Cyt14/");
  tsr->setFilename("prune.tcl");
  BaseGraph* graph2 = tsr->getBaseGraph();

  printf("\n\n");

  // Tessellator
  printf("*** Tessellator Test ***\n");
  Tessellator* tessellator = new Tessellator(ac2, graph2->getVertexCount(), graph2->getCoords(), graph2->getConnectionMatrix());
  //tessellator->setHebbian(0);
  tessellator->setStepNum(200000);
  FILE* out = fopen("tess01.tcl","w");
  tessellator->printTessellationScript(out);
  fclose(out);
  for (int i=1; i<=800000; i++) {
    tessellator->stepTessellation();
    if (i == 10) {
      out = fopen("tess02.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 100) {
      out = fopen("tess03.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 1000) {
      out = fopen("tess04.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 10000) {
      out = fopen("tess05.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 25000) {
      out = fopen("tess06.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 50000) {
      out = fopen("tess07.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 75000) {
      out = fopen("tess08.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 100000) {
      out = fopen("tess09.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }



    else if (i == 125000) {
      out = fopen("tess10.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 150000) {
      out = fopen("tess11.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 175000) {
      out = fopen("tess12.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 200000) {
      out = fopen("tess13.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 225000) {
      out = fopen("tess14.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 250000) {
      out = fopen("tess15.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 275000) {
      out = fopen("tess16.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 300000) {
      out = fopen("tess17.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 325000) {
      out = fopen("tess18.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 350000) {
      out = fopen("tess19.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 375000) {
      out = fopen("tess20.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 400000) {
      out = fopen("tess21.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 450000) {
      out = fopen("tess22.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 500000) {
      out = fopen("tess23.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 550000) {
      out = fopen("tess24.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }



    else if (i == 600000) {
      out = fopen("tess25.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 700000) {
      out = fopen("tess26.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 800000) {
      out = fopen("tess27.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 900000) {
      out = fopen("tess28.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 1000000) {
      out = fopen("tess29.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    else if (i == 1200000) {
      out = fopen("tess30.tcl","w");
      tessellator->printTessellationScript(out);
      fclose(out);
    }
    if (i%1000 == 0) {
      printf(" -- %d, adds: %d\n", i, tessellator->getAddTracker());
      tessellator->resetAddTracker();
      if (tessellator->areVerticesStable() == 1) {
	out = fopen("tess11.tcl","w");
	tessellator->printTessellationScript(out);
	fclose(out);
	printf(" -- %d, Simulated Annealing Completed\n", i);
	break;
      }
    }
  }

  printf("\n\n");


  // TessellationScriptReader
  printf("*** TessellationScriptReader Test 2 ***\n");
  TessellationScriptReader* tsr2 = new TessellationScriptReader();
  tsr2->setPath("./");
  tsr2->setFilename("tess27.tcl");
  BaseGraph* graph3 = tsr2->getBaseGraph();
  graph3->deactivateLongEdges();
  FILE* outfile = fopen("prune2.tcl","w");
  graph3->printTessellationScript(outfile);
  fclose(outfile);

  printf("\n\n");


  // TriangleGraph
  printf("*** TriangleGraph Test ***\n");
  TriangleGraph* tGraph2 = graph3->getTriangleGraph();
  //tGraph2->print();
  outfile = fopen("surface2.tcl","w");
  tGraph2->printTessellationScript(outfile);
  fclose(outfile);

  printf("\n\n");


  return 0;
}
