
#include "atom.h"
#include "atomCluster.h"
#include "baseGraph.h"
#include "baseVertexNodeTree.h"
#include "box.h"
#include "connectionMatrix.h"
#include "coordinate3D.h"
#include "element.h"
#include "elementBuilder.h"
#include "genericList.h"
#include "groupId.c"
#include "neuronList.h"
#include "pdbReader.h"
#include "tessellationScriptReader.h"
#include "tessellator.h"
#include "triangleGraph.h"
#include "triangleGraphNode.h"

#include <stdio.h>
//#include <stdlib.h>


int main (int argc, char** argv) {


  // TessellationScriptReader
  printf("*** TessellationScriptReader Test 1 ***\n");
  TessellationScriptReader* tsr = new TessellationScriptReader();
  tsr->setPath("./HisHFPlay/");
  tsr->setFilename("prune.tcl");
  BaseGraph* graph2 = tsr->getBaseGraph();

  printf("\n\n");


  // TessellationScriptReader
  printf("*** TessellationScriptReader Test 2 ***\n");
  TessellationScriptReader* tsr2 = new TessellationScriptReader();
  tsr2->setPath("./HisHFPlay/");
  tsr2->setFilename("prune2.tcl");
  BaseGraph* graph3 = tsr2->getBaseGraph();
  //graph3->deactivateLongEdges();
  graph3->compareVertexPositions(graph2);
  FILE* outfile = fopen("colorPrune.tcl","w");
  graph3->printTessellationScript(outfile,1);
  fclose(outfile);
  printf("\n\n");


  // TriangleGraph
  printf("*** TriangleGraph Test ***\n");
  TriangleGraph* tGraph2 = graph3->getTriangleGraph();
  //tGraph2->print();
  outfile = fopen("colorSurface.tcl","w");
  tGraph2->printTessellationScript(outfile,1);
  fclose(outfile);

  printf("\n\n");


  return 0;
}
